import javax.naming.* ;
import java.sql.*;
import javax.sql.*;

public class AgencyTable
{
    public static void main(String args[]) {
        try {
            AgencyTable at = new AgencyTable();
            for (int i=0; i<args.length; i++)
                at.printTable(args[i]);
        }
        catch (NamingException ex) {
            System.out.println ("Error connecting to jdbc/Agency: "+ex);
        }
         catch (SQLException ex) {
            System.out.println ("Error getting table rows: "+ex);
        }
    }
    
   private DataSource dataSource;

    public AgencyTable () throws NamingException {
        InitialContext ic = new InitialContext();
        dataSource = (DataSource)ic.lookup("jdbc/Agency");
    }

    public void printTable(String table) throws SQLException {
        Connection con = null;
        PreparedStatement stmt = null;
        ResultSet rs = null;
        try {
            con = dataSource.getConnection();
            stmt = con.prepareStatement("SELECT * FROM "+table);

            rs = stmt.executeQuery();
            ResultSetMetaData rsmd = rs.getMetaData();
            int numCols = rsmd.getColumnCount();

            // get column header info
            for (int i=1; i <= numCols; i++) {
                System.out.print (rsmd.getColumnLabel(i));  
                if (i > 1) 
                    System.out.print (',');  
            }
            System.out.println ();

            while (rs.next()) {
                for (int i=1; i <= numCols; i++) {
                    System.out.print (rs.getString(i));  
                    if (i > 1) 
                        System.out.print (',');  
                    }
                System.out.println ();
            }
        }
        finally {
            try {rs.close();} catch (Exception ex) {}
            try {stmt.close();} catch (Exception ex) {}
            try {con.close();} catch (Exception ex) {}
        }
    }
}
