import javax.naming.*;

public class JNDIList
{
    public static void main(String[] args)
    {
        try {
            Context ctx = new InitialContext();
            if (args.length == 0) {
                listContext(ctx,"");
            }
            else {
                for (int i=0; i<args.length; i++) 
                    listContext (ctx,args[i]);
            }
        }
        catch (NamingException ex) {
            ex.printStackTrace();
            System.exit(1);
        }
    }
    
    public static void listContext (Context ctx, String subctx) 
        throws NamingException
    {
        System.out.println("Listing Context: "+subctx);
        NamingEnumeration list = ctx.list(subctx);
        while (list.hasMore())
        {
            NameClassPair item = (NameClassPair)list.next();
            String cl = item.getClassName();
            String name = item.getName();
            System.out.println(cl+" - "+name);
        }
    }
}
