import javax.swing.*;
import javax.swing.tree.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.naming.*;

public class JNDIBrowserSort extends JPanel
{
    public static void main(String[] args) {
    	final JFrame window = new JFrame("JNDI Browser");
    	try {
	        final JNDIBrowserSort client = new JNDIBrowserSort();
	    	window.addWindowListener(new WindowAdapter() {
	    		public void windowClosing( WindowEvent ev) {
	    			window.dispose();
					System.exit(0); 			
	    		}
	    	});
	    	Container cp = window.getContentPane();
	    	cp.add(client,BorderLayout.CENTER);
	   		window.pack();
	    	window.setVisible(true);
    	}
    	catch (Exception ex) {
 	    	System.err.println(ex);
	    	window.dispose();
	    	System.exit(1);
    	}
    }

    public JNDIBrowserSort() {
		Context ctx=null;
		try {
		   	DefaultMutableTreeNode root = new DefaultMutableTreeNode("JNDI");
			ctx = new InitialContext();
			addContext (root,ctx);
	    	JTree tree = new JTree(root);
	    	add (new JScrollPane(tree));
		} 
		catch (NamingException ex) {
			System.err.println (ex);
			System.exit(1);
		}
    }

	private static void addContext (DefaultMutableTreeNode node, Context ctx) throws NamingException{
		NamingEnumeration list = ctx.listBindings("");
		Map sorted = new TreeMap();
		while (list.hasMore()) {
			Binding item = (Binding)list.next();
			sorted.put(item.getName(),item);
		}
		Iterator keys = sorted.keySet().iterator();
		while (keys.hasNext()) {
			String name = (String)keys.next();
			Binding item = (Binding)sorted.get(name);
			DefaultMutableTreeNode child = new DefaultMutableTreeNode(name);
			node.add (child);
			Object o = item.getObject();
			if (o instanceof javax.naming.Context)
				addContext (child,(Context)o);
		}
	}   	
}


